﻿using System;
namespace Facade.Ejm1
{
    /// <summary>
    /// Fachada
    /// </summary>
    public class CustomerFacade
    {
        private string Address;
        private string City;
        private string State;
        private string CardType;
        private string CardNumber;
        private string CardExpDate;
        private string FirstName;
        private string LastName;

        public void SetAddress(string inAddress)
        {
            Address = inAddress;
        }

        public void SetCity(string inCity)
        {
            City = inCity;
        }

        public void SetState(string inState)
        {
            State = inState;
        }

        public void SetFName(string inFName)
        {
            FirstName = inFName;
        }

        public void SetLName(string inLName)
        {
            LastName = inLName;
        }

        public void SetCardType(string inCardType)
        {
            CardType = inCardType;
        }

        public void SetCardNumber(string inCardNumber)
        {
            CardNumber = inCardNumber;
        }

        public void SetCardExpDate(string inCardExpDate)
        {
            CardExpDate = inCardExpDate;
        }

        public bool SaveCustomerData()
        {
            Address objAddress;
            Account objAccount;
            CreditCard objCreditCard;
            /*
             * client is transparent from the following set of subsystem related
             * operations.
             */
            bool validData = true;
            string errorMessage = "";
            objAccount = new Account(FirstName, LastName);
            if (objAccount.IsValid() == false)
            {
                validData = false;
                errorMessage = "Invalid FirstName/LastName";
            }
            objAddress = new Address(Address, City, State);
            if (objAddress.IsValid() == false)
            {
                validData = false;
                errorMessage = "Invalid Address/City/State";
            }
            objCreditCard = new CreditCard(CardType, CardNumber, CardExpDate);
            if (objCreditCard.IsValid() == false)
            {
                validData = false;
                errorMessage = "Invalid CreditCard Info";
            }
            if (!validData)
            {
                Console.WriteLine(errorMessage);
                return false;
            }
            if (objAddress.Save() && objAccount.Save() && objCreditCard.Save())
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }

}
